(* Title:  "Interpret/lucas-interpreter.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- Take as 1st stac in program -------------------------------------------------------";
"----------- re-build: fun locate_input_tactic -------------------------------------------------";
"----------- fun locate_input_tactic Helpless, NOT applicable ----------------------------------";
"----------- re-build: fun find_next_step, mini ------------------------------------------------";
"----------- re-build: fun locate_input_term ---------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

"----------- Take as 1st stac in program -------------------------------------------------------";
"----------- Take as 1st stac in program -------------------------------------------------------";
"----------- Take as 1st stac in program -------------------------------------------------------";
"compare --- Apply_Method with initial Take by Step.do_next --- in test/../step-solve ----------";
val p = e_pos'; val c = []; 
val (p,_,f,nxt,_,pt) = 
    CalcTreeTEST 
        [(["functionTerm (x \<up> 2 + 1)", "integrateBy x", "antiDerivative FF"],
          ("Integrate", ["integrate", "function"], ["diff", "integration"]))];
val (p,_,f,nxt,_,pt) = me nxt p c pt; (*nxt = ("Tac ", ...) --> Add_Given...*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (Apply_Method ["diff", "integration"]) => ()
          | _ => error "integrate.sml -- me method [diff,integration] -- spec";
"----- step 8: returns nxt = Rewrite_Set_Inst ([\"(''bdv'', x)\"],\"integration\")";

"~~~~~ fun me, args:"; val (tac, (p:pos'), _, (pt:ctree)) = (nxt, p, c, pt);
"~~~~~ fun Step.by_tactic, args:"; val (tac, (ptp as (pt, p))) = (tac, (pt,p));
val Applicable.Yes m = Step.check tac (pt, p);
 (*if*) Tactic.for_specify' m; (*false*)
"~~~~~ fun loc_solve_ , args:"; val (m, (pt,pos)) = (m, ptp);

"~~~~~ fun Step_Solve.by_tactic , args:"; val (m as Apply_Method' (mI, _, _, ctxt), (pt, (pos as (p,_))))
  = (m, (pt, pos));
      val {srls, ...} = MethodC.from_store ctxt mI;
      val itms = case get_obj I pt p of
        PblObj {meth=itms, ...} => itms
      | _ => error "solve Apply_Method: uncovered case get_obj"
      val thy' = get_obj g_domID pt p;
      val thy = ThyC.get_theory thy';
      val srls = LItool.get_simplifier (pt, pos)
      val (is, env, ctxt, sc) = case LItool.init_pstate srls ctxt itms mI of
        (is as Istate.Pstate {env, ...}, ctxt, sc) =>  (is, env, ctxt, sc)
      | _ => error "solve Apply_Method: uncovered case init_pstate";
(*+*)pstate2str (the_pstate is) = "([\"\n(f_f, x \<up> 2 + 1)\",\"\n(v_v, x)\"], [], empty, NONE, \n??.empty, ORundef, false, true)";
      val ini = LItool.implicit_take sc env;
      val p = lev_dn p;

      val NONE = (*case*) ini (*of*);
            val Next_Step (is', ctxt', m') =
              LI.find_next_step sc (pt, (p, Res)) is ctxt;
(*+*)pstate2str (the_pstate is') = "([\"\n(f_f, x \<up> 2 + 1)\",\"\n(v_v, x)\"], [R,L,R], empty, NONE, \nIntegral x \<up> 2 + 1 D x, ORundef, false, false)";
  val Safe_Step (_, _, Take' _) = (*case*)
           locate_input_tactic sc (pt, (p, Res)) is' ctxt' m' (*of*);
"~~~~~ fun locate_input_tactic , args:"; val ((Prog prog), cstate, istate, ctxt, tac)
  = (sc, (pt, (p, Res)), is', ctxt', m');

    (*case*) scan_to_tactic1 (prog, (cstate, ctxt, tac)) istate (*of*);
"~~~~~ fun scan_to_tactic1 , args:"; val ((prog, (cctt as ((_, p), _, _))), (Istate.Pstate (ist as {path, ...})))
  = ((prog, (cstate, ctxt, tac)), istate);
    (*if*) path = [] orelse ((last_elem o fst) p = 0 andalso snd p = Res) (*then*);

  val Accept_Tac1 (_, _, Take' _) =
       scan_dn1 cctt (ist |> set_path [R] |> set_or ORundef) (Program.body_of prog);
"~~~~~ fun scan_dn1 , args:"; val (xxx, ist, (Const (\<^const_name>\<open>Let\<close>, _) $ e $ (Abs (id, T, b))))
  = (cctt, (ist |> set_path [R] |> set_or ORundef), (Program.body_of prog));

(*+*) if UnparseC.term e = "Take (Integral f_f D v_v)" then () else error "scan_dn1 Integral changed";

    (*case*)
           scan_dn1 xxx (ist |> path_down [L, R]) e (*of*);
    (*======= end of scanning tacticals, a leaf =======*)
"~~~~~ fun scan_dn1 , args:"; val (((pt, p), ctxt, tac), (ist as {eval, or, ...}), t)
  = (xxx, (ist |> path_down [L, R]), e);
val (Program.Tac stac, a') = check_leaf "locate" ctxt eval (get_subst ist) t;



"----------- re-build: fun locate_input_tactic -------------------------------------------------";
"----------- re-build: fun locate_input_tactic -------------------------------------------------";
"----------- re-build: fun locate_input_tactic -------------------------------------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = (_, Apply_Method ["Test", "squ-equ-test-subpbl1"])*);
(*[1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = ("Rewrite_Set", Rewrite_Set "norm_equation")*)

(*//------------------ begin step into ------------------------------------------------------\\*)
(*[1], Res*)val (p'''''_''',_,f,nxt'''''_''',_,pt'''''_''') = me nxt p [] pt; (*nxt = Rewrite_Set "Test_simplify"*)

"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, [], pt);

    (** )val (***)xxxx(***) ( *("ok", (_, _, (pt, p))) =( **)  (*case*)
      Step.by_tactic tac (pt,p) (*of*);
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt,p));
      val Applicable.Yes m = (*case*) Solve_Step.check tac (pt, p) (*of*);
      (*if*) Tactic.for_specify' m; (*false*)

    (** )val (***)xxxxx_x(***) ( *(msg, cs') =( **)
Step_Solve.by_tactic m ptp;
"~~~~~ fun by_tactic , args:"; val (m, (pt, po as (p, p_))) = (m, ptp);
(*+*)val (pt'''''_', (p'''''_', p_'''''_')) = (pt, (p, p_));
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p); (*else*)
	      val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val (is, sc) = LItool.resume_prog (p,p_) pt;

     locate_input_tactic sc (pt, po) (fst is) (snd is) m;
"~~~~~ fun locate_input_tactic , args:"; val (Prog prog, cstate, istate, ctxt, tac)
    = (sc, (pt, po), (fst is), (snd is), m);
      val srls = get_simplifier cstate;

 (** )val Accept_Tac1 ((is as (_,_,_,_,_,strong_ass), ctxt, ss as((tac', _, ctree, pos', _) :: _))) =( **)
  (*case*) scan_to_tactic1 (prog, (cstate, ctxt, tac)) istate (*of*);
"~~~~~ fun scan_to_tactic1 , args:"; val ((prog, (cctt as ((_, p), _, _))), (Istate.Pstate (ist as {path, ...})))
  = ((prog, (cstate, ctxt, tac)), istate);
    (*if*) path = [] orelse ((last_elem o fst) p = 0 andalso snd p = Res) (*then*);

    (** )val xxxxx_xx = ( **)
           scan_dn1 cctt (ist |> set_path [R] |> set_or ORundef) (Program.body_of prog);
"~~~~~ fun scan_dn1 , args:"; val (xxx, ist, (Const (\<^const_name>\<open>Let\<close>, _) $ e $ (Abs (id, T, b))))
  = (cctt, (ist |> set_path [R] |> set_or ORundef), (Program.body_of prog));

  (*case*) scan_dn1 xxx (ist |> path_down [L, R]) e (*of*);
"~~~~~ fun scan_dn1 , args:"; val ((xxx as (cstate, _, _)), ist, (Const (\<^const_name>\<open>Chain\<close>(*1*), _) $ e1 $ e2 $ a))
  = (xxx, (ist |> path_down [L, R]), e);

  (*case*) scan_dn1 xxx (ist |> path_down_form ([L, L, R], a)) e1 (*of*);
"~~~~~ fun scan_dn1 , args:"; val (xxx, ist, (Const (\<^const_name>\<open>Try\<close>(*2*), _) $ e))
  = (xxx, (ist |> path_down_form ([L, L, R], a)), e1);

  (*case*) scan_dn1 xxx (ist |> path_down [R]) e (*of*);
    (*======= end of scanning tacticals, a leaf =======*)
"~~~~~ fun scan_dn1 , args:"; val (((pt, p), ctxt, tac), (ist as {env, eval, or, ...}), t)
  = (xxx, (ist |> path_down [R]), e);
    val (Program.Tac stac, a') =
      (*case*) check_leaf "locate" ctxt eval (get_subst ist) t (*of*);
    val LItool.Associated (m, v', ctxt) =
      (*case*) associate pt ctxt (m, stac) (*of*);

       Accept_Tac1 (ist |> set_subst_true  (a', v'), ctxt, m)  (*return value*);
"~~~~~ from scan_dn1 to scan_to_tactic1 return val:"; val (xxxxx_xx)
  = (Accept_Tac1 (ist |> set_subst_true  (a', v'), ctxt, m));

"~~~~~ from scan_to_tactic1 to fun locate_input_tactic return val:"; val Accept_Tac1 ((ist as {assoc, ...}), ctxt, tac')
  = (Accept_Tac1 (ist |> set_subst_true  (a', v'), ctxt, m));
        (*if*) LibraryC.assoc (*then*);

       Safe_Step (Istate.Pstate ist, ctxt, tac')  (*return value*);
"~~~~~ from locate_input_tactic to fun Step_Solve.by_tactic return:"; val Safe_Step (istate, ctxt, tac)
  = (*xxxxx_xx*)(**)Safe_Step (Istate.Pstate ist, ctxt, tac')(**);

(*+*)val (pt, po as (p, p_)) = (pt'''''_', (p'''''_', p_'''''_')); (* from begin of by_tactic *)
                  val (p'', _, _,pt') =
                    Step.add tac (istate, ctxt) (pt, (lev_on p, Pbl));
            (*in*)

         	  	    ("ok", ([(Tactic.input_from_T tac, tac, (p'', (istate, ctxt)))],
                    [(*ctree NOT cut*)], (pt', p'')))  (*return value*);
"~~~~~ from Step_Solve.by_tactic \<longrightarrow> Step.by_tactic return:"; val ((msg, cs' : Calc.state_post))
  =               ("ok", ([(Tactic.input_from_T tac, tac, (p'', (istate, ctxt)) )],
                    [(*ctree NOT cut*)], (pt', p'')));

"~~~~~ from Step.by_tactic to me return:"; val (("ok", (_, _, (pt, p)))) = (*** )xxxx( ***) ("ok", cs');
	  val (_, ts) =
	    (case Step.do_next p ((pt, Pos.e_pos'), []) of
		    ("ok", (ts as (_, _, _) :: _, _, _)) => ("", ts)
	    | ("helpless", _) => ("helpless: cannot propose tac", [])
	    | ("no-fmz-spec", _) => error "no-fmz-spec"
	    | ("end-of-calculation", (ts, _, _)) => ("", ts)
	    | _ => error "me: uncovered case")
	      handle ERROR msg => raise ERROR msg
	  val tac = 
      case ts of 
        tacis as (_::_) => let val (tac, _, _) = last_elem tacis in tac end 
		  | _ => if p = ([], Pos.Res) then Tactic.End_Proof' else Tactic.Empty_Tac;

   (p, [] : NEW, TESTg_form (pt, p), (Tactic.tac2IDstr tac, tac), Celem.Sundef, pt);
"~~~~~ from me to TOOPLEVEL return:"; val (p,_,f,nxt,_,pt)
   = (*** )xxx( ***) (p, [] : NEW, TESTg_form (pt, p), (Tactic.tac2IDstr tac, tac), Celem.Sundef, pt);

(*//--------------------- check results from modified me ----------------------------------\\*)
if p = ([2], Res) andalso
  pr_ctree pr_short pt = ".    ----- pblobj -----\n1.   x + 1 = 2\n2.   x + 1 = 2\n"
then
  (case nxt of ("Rewrite_Set", Rewrite_Set "Test_simplify") => ()
   | _ => error "")
else error "check results from modified me CHANGED";
(*\\--------------------- check results from modified me ----------------------------------//*)

"~~~~~ from me to TOPLEVEL return:"; val (p,_,f,nxt,_,pt) = (*** )xxx( ***) (**)(p, 000, f, nxt, 000, pt)(**);
(*\\------------------ end step into --------------------------------------------------------//*)

(*[3], Res*)val (p,_,f,nxt,_,pt) = me nxt'''''_''' p'''''_''' [] pt'''''_'''; (*nxt = Subproblem ("Test", ["LINEAR", "univariate", "equation", "test"])*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Model_Problem*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Given "equality (- 1 + x = 0)"*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Given "solveFor x"*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Find "solutions x_i"*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Theory "Test"*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Problem ["LINEAR", "univariate", "equation", "test"]*)
(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Method ["Test", "solve_linear"]*)
(*[3], Met*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Apply_Method ["Test", "solve_linear"]*)
(*[3, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set_Inst (["(''bdv'', x)"], "isolate_bdv")*)
(*[3, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set "Test_simplify"*)
(*[3, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Check_Postcond ["LINEAR", "univariate", "equation", "test"]*)
(*[3], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Check_elementwise "Assumptions"*)
(*[4], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Check_Postcond ["sqroot-test", "univariate", "equation", "test"]*)
(*[], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = End_Proof'*)

(*/--------------------- final test ----------------------------------\\*)
if p = ([], Res) andalso f2str f = "[x = 1]" andalso pr_ctree pr_short pt =
  ".    ----- pblobj -----\n" ^
  "1.   x + 1 = 2\n" ^
  "2.   x + 1 + - 1 * 2 = 0\n" ^
  "3.    ----- pblobj -----\n" ^
  "3.1.   - 1 + x = 0\n" ^
  "3.2.   x = 0 + - 1 * - 1\n" ^
  "4.   [x = 1]\n"
then case nxt of End_Proof' => () | _ => error "re-build: fun locate_input_tactic changed 1"
else error "re-build: fun locate_input_tactic changed 2";


"----------- fun locate_input_tactic Helpless, NOT applicable ----------------------------------";
"----------- fun locate_input_tactic Helpless, NOT applicable ----------------------------------";
"----------- fun locate_input_tactic Helpless, NOT applicable ----------------------------------";
(*cp from -- try fun applyTactics ------- *)
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(["Term (5*e + 6*f - 8*g - 9 - 7*e - 4*f + 10*g + 12)",
	    "normalform N"],
	   ("PolyMinus",["plus_minus", "polynom", "vereinfachen"],
	    ["simplification", "for_polynomials", "with_minus"]))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt; val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set "ordne_alphabetisch"*)

(*+*)val Test_Out.FormKF "5 * e + 6 * f - 8 * g - 9 - 7 * e - 4 * f + 10 * g + 12" = f

(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set "fasse_zusammen"*)

(*+*)if map Tactic.input_to_string (specific_from_prog pt p) =
   ["Rewrite (\"subtrahiere_x_plus_minus\", \"\<lbrakk>?l is_num; ?m is_num\<rbrakk>\n\<Longrightarrow> ?x + ?m * ?v - ?l * ?v = ?x + (?m - ?l) * ?v\")",
    "Rewrite (\"subtrahiere_x_minus_plus\", \"\<lbrakk>?l is_num; ?m is_num\<rbrakk>\n\<Longrightarrow> ?x - ?m * ?v + ?l * ?v = ?x + (- ?m + ?l) * ?v\")",
(*this is new since ThmC.numerals_to_Free.-----\\*)
    "Calculate PLUS"]
  then () else error "specific_from_prog ([1], Res) 1 CHANGED";
(*[2], Res*)val ("ok", (_, _, ptp as (pt, p))) = Step.by_tactic (hd (specific_from_prog pt p)) (pt, p);

(*+*)if map Tactic.input_to_string (specific_from_prog pt p) = [
  "Rewrite (\"tausche_minus\", \"\<lbrakk>?b ist_monom; ?a kleiner ?b\<rbrakk>\n\<Longrightarrow> ?b - ?a = - ?a + ?b\")",
  "Rewrite (\"subtrahiere_x_plus_minus\", \"\<lbrakk>?l is_num; ?m is_num\<rbrakk>\n\<Longrightarrow> ?x + ?m * ?v - ?l * ?v = ?x + (?m - ?l) * ?v\")",
  "Rewrite (\"subtrahiere_x_minus_plus\", \"\<lbrakk>?l is_num; ?m is_num\<rbrakk>\n\<Longrightarrow> ?x - ?m * ?v + ?l * ?v = ?x + (- ?m + ?l) * ?v\")",
  (*this is new since ThmC.numerals_to_Free.-----\\*)
  "Calculate PLUS",
  (*this is new since ThmC.numerals_to_Free.-----//*)
  "Calculate MINUS"]
  then () else error "specific_from_prog ([1], Res) 2 CHANGED";
(* = ([3], Res)*)val ("ok", (_, _, ptp as (pt, p))) = Step.by_tactic (hd (specific_from_prog pt p)) (pt, p);

(*//----------------- exception PTREE "get_obj f EmptyPtree" raised --------------------------\\*)
(**)val ("ok", ([(Rewrite ("tausche_minus", _), _, _)], _, _)) = (*isa*)
      Step.by_tactic (hd (specific_from_prog pt p)) (pt, p);
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (hd (specific_from_prog pt p), (pt, p));
      val Applicable.Yes m = (*case*) Solve_Step.check tac (pt, p) (*of*);
      (*if*) Tactic.for_specify' m; (*false*)

(**) val ("ok", ([(Rewrite ("tausche_minus", _), _, _)], _, _)) = (*isa*)
Step_Solve.by_tactic m (pt, p);
"~~~~~ fun by_tactic , args:"; val (m, (pt, po as (p, p_))) = (m, (pt, p));
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val (is, sc) = LItool.resume_prog (p,p_) pt;

  (*case*) locate_input_tactic sc (pt, po) (fst is) (snd is) m (*of*);
"~~~~~ fun locate_input_tactic , args:"; val ((Rule.Prog prog), (cstate as (pt, (*?*)pos(*?*))), istate, ctxt, tac)
  = (sc, (pt, po), (fst is), (snd is), m);
      val srls = LItool.get_simplifier cstate (*TODO: shift into Istate.T*);

  (*case*) scan_to_tactic1 (prog, (cstate, ctxt, tac)) istate (*of*);
"~~~~~ fun scan_to_tactic1 , args:"; val ((prog, (cctt as ((_, p), _, _))), (Istate.Pstate (ist as {path, ...})))
  = ((prog, (cstate, ctxt, tac)), istate);
    (*if*) path = [] orelse ((last_elem o fst) p = 0 andalso snd p = Res) (*else*);

           go_scan_up1 (prog, cctt) ist;
"~~~~~ fun go_scan_up1 , args:"; val ((pcct as (prog, _)), (ist as {path, ...}))
  = ((prog, cctt), ist);
  (*if*) 1 < length path (*then*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val (pcct, ist, (Const (\<^const_name>\<open>Try\<close>(*2*), _) $ _))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));

           go_scan_up1 pcct ist;
"~~~~~ and go_scan_up1 , args:"; val ((pcct as (prog, _)), (ist as {path, ...}))
  = (pcct, ist);
  (*if*) 1 < length path (*then*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val ((pcct as (prog, cct as (cstate, _, _))), ist,
    (Const (\<^const_name>\<open>Chain\<close>(*3*), _) $ _ ))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));
       val e2 = check_Seq_up ist prog
;
  (*case*) scan_dn1 cct (ist |> path_up_down [R] |> set_or ORundef) e2 (*of*);
"~~~~~ fun scan_dn1 , args:"; val (yyy, ist, (Const (\<^const_name>\<open>Chain\<close>(*2*), _) $ e1 $ e2))
  = (cct, (ist |> path_up_down [R] |> set_or ORundef), e2);

  (*case*) scan_dn1 cct (ist |> path_down [L, R]) e1 (*of*);
"~~~~~ fun scan_dn1 , args:"; val (xxx, ist, (Const (\<^const_name>\<open>Try\<close>(*2*), _) $ e))
  = (cct, (ist |> path_down [L, R]), e1);

  (*case*) scan_dn1 cct (ist |> path_down [R]) e (*of*);
    (*======= end of scanning tacticals, a leaf =======*)
"~~~~~ fun scan_dn1 , args:"; val ((cct as (_, ctxt, _)), (ist as {eval, ...}), t)
  = (cct, (ist |> path_down [R]), e);
    (*if*) Tactical.contained_in t (*else*);
  val (Program.Tac prog_tac, form_arg) = (*case*)
    LItool.check_leaf "locate" ctxt eval (get_subst ist) t (*of*);

           check_tac1 cct ist (prog_tac, form_arg);
"~~~~~ fun check_tac1 , args:"; val (((pt, p), ctxt, tac), (ist as {act_arg, or, ...}), (prog_tac, form_arg)) =
  (cct, ist, (prog_tac, form_arg));
val LItool.Not_Associated = (*case*)
  LItool.associate pt ctxt (tac, prog_tac) (*of*);
     val _(*ORundef*) = (*case*) or (*of*);

(*+*)Solve_Step.check (LItool.tac_from_prog pt (ThyC.get_theory "Isac_Knowledge") prog_tac) (pt, p);

     val Applicable.Yes m' =
          (*case*) Solve_Step.check (LItool.tac_from_prog pt (ThyC.get_theory "Isac_Knowledge") prog_tac) (pt, p) (*of*);

  Reject_Tac1 (ist |> set_subst_false (form_arg, Tactic.result m'), ctxt, tac)
          (*return from check_tac1*);
"~~~~~ from fun check_tac1 \<longrightarrow>fun scan_dn1 \<longrightarrow>fun scan_dn1  \<longrightarrow>fun locate_input_tactic , return:"; val (Reject_Tac1 _) =
  (Reject_Tac1 (ist |> set_subst_false (form_arg, Tactic.result m'), ctxt, tac));

val Test_Out.FormKF "- 9 + 12 + 5 * e - 7 * e + 6 * f - 4 * f - 8 * g + 10 * g" = f;
val ([3], Res) = p;


"----------- re-build: fun find_next_step, mini ------------------------------------------------";
"----------- re-build: fun find_next_step, mini ------------------------------------------------";
"----------- re-build: fun find_next_step, mini ------------------------------------------------";
val fmz = ["Term (a + a ::real)", "normalform n_n"];
val (dI',pI',mI') = ("Poly",["polynomial", "simplification"],["simplification", "for_polynomials"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, Pos.e_pos'), []);(*Model_Problem*)
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, Pos.e_pos'), []);(*Specify_Theory "Poly"*)
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, Pos.e_pos'), []);(*Specify_Problem ["polynomial", "simplification"]*)
(*[], Met*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Specify_Method  ["simplification", "for_polynomials"]*)
(*1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Apply_Method ["simplification", "for_polynomials"]*)
(*[1], Res*)val (_, ([(tac'''''_', _, _)], _, (pt'''''_', p'''''_'))) =

      Step.do_next p ((pt, e_pos'), []);(*Rewrite_Set "norm_Poly"*)
(*//------------------ go into 1 ------------------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, e_pos'), []));
  val pIopt = Ctree.get_pblID (pt, ip);
    (*if*)  ip = ([], Res) (*else*);
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);
      (*if*) member op = [Pos.Pbl, Pos.Met] p_ (*else*);

val ("ok", ([(Rewrite_Set "norm_Poly", _, _)], _, (_, ([1], Res)))) =
Step_Solve.do_next (pt, ip);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) =  (pt, ip);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
        val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

val Next_Step (_, _, Rewrite_Set' ("Poly", _, Rule_Set.Sequence {id = "norm_Poly", ...}, _, _)) =
           LI.find_next_step sc (pt, pos) ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as(pt, (p, _))), (Pstate ist), ctxt)
  = (sc, (pt, pos), ist, ctxt);

val Accept_Tac (Rewrite_Set' ("Poly", _, Rule_Set.Sequence {id = "norm_Poly", ...}, _, _), _, _) =
  (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...})))
  = ((prog, (ptp, ctxt)), (Pstate ist));
  (*if*) path = [] (*then*);

val Accept_Tac (Rewrite_Set' ("Poly", _, Rule_Set.Sequence {id = "norm_Poly", ...}, _, _), _, _) =
            scan_dn cc (trans_scan_dn ist) (Program.body_of prog);
"~~~~~ fun scan_dn , args:"; val ((cc as (_, ctxt)), (ist as {eval, ...}), t)
  = (cc, (trans_scan_dn ist), (Program.body_of prog));
    (*if*) Tactical.contained_in t (*else*);
      val (Program.Tac prog_tac, form_arg) = (*case*) LItool.check_leaf "next  " ctxt eval (get_subst ist) t (*of*);

val Accept_Tac (Rewrite_Set' ("Poly", _, Rule_Set.Sequence {id = "norm_Poly", ...}, _, _), _, _) =
          check_tac cc ist (prog_tac, form_arg)  (*return from xxx*);
"~~~~~ from fun scan_dn\<longrightarrow>fun scan_to_tactic\<longrightarrow>fun find_next_step, return:"; val (Accept_Tac (tac, ist, ctxt))
  = (check_tac cc ist (prog_tac, form_arg));

    Next_Step (Pstate ist, Tactic.insert_assumptions tac ctxt, tac)  (*return from find_next_step*);
"~~~~~ from fun find_next_step\<longrightarrow>and do_next\<longrightarrow>fun zzz, return:"; val (Next_Step (ist, ctxt, tac))
  = (Next_Step (Pstate ist, Tactic.insert_assumptions tac ctxt, tac));

           LI.by_tactic tac (ist, Tactic.insert_assumptions tac ctxt) ptp  (*return from and do_next*);
"~~~~~ from and do_next\<longrightarrow>fun do_next\<longrightarrow>toplevel, return:"; val  (_, ([(tac''''', _, _)], _, (pt''''', p''''')))
  = (LI.by_tactic tac (ist, Tactic.insert_assumptions tac ctxt) ptp);
(*\\------------------ end of go into 1 -----------------------------------------------------//*)

(*[], Res*)val (_, ([(tac''''', _, _)], _, (pt''''', p'''''))) =

      Step.do_next p'''''_' ((pt'''''_', Pos.e_pos'), []);(* Check_Postcond ["polynomial", "simplification"]*)
(*//------------------ go into 2 ------------------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p''''', ((pt''''', e_pos'), []));
  val pIopt = Ctree.get_pblID (pt, ip);
    (*if*)  ip = ([], Res) (*else*);
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);
      (*if*) member op = [Pos.Pbl, Pos.Met] p_ (*else*);

val ("ok", ([(Check_Postcond ["polynomial", "simplification"], _, _)], _, (_, ([], Res)))) =
Step_Solve.do_next (pt, ip);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) =  (pt, ip);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
        val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

  (** )val End_Program (ist, tac) = 
 ( *case*) LI.find_next_step sc (pt, pos) ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as(pt, (p, _))), (Pstate ist), ctxt)
  = (sc, (pt, pos), ist, ctxt);

(*  val Term_Val (Const (\<^const_name>\<open>times\<close>, _) $ Free ("2", _) $ Free ("a", _))*)
  (**)val Term_Val prog_result =
 (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...})))
  = ((prog, (ptp, ctxt)), (Pstate ist));
  (*if*) path = [] (*else*);

           go_scan_up (prog, cc) (trans_scan_up ist |> set_found);
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...}))
  = ((prog, cc), (trans_scan_up ist(*|> set_found !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! *)));
    (*if*) path = [R] (*then*);
      (*if*) found_accept = true (*then*);

      Term_Val act_arg (*return from go_scan_up*);
"~~~~~ from fun go_scan_up\<longrightarrow>fun scan_to_tactic, return:"; val (Term_Val prog_result) = (Term_Val act_arg);

    Term_Val prog_result  (*return from scan_to_tactic*);
"~~~~~ from fun scan_to_tactic\<longrightarrow>fun find_next_step, return:"; val (Term_Val prog_result) = (Term_Val prog_result);
    val (true, p' as [], Rule_Set.Empty, _) = (*case*) parent_node pt pos (*of*);
              val (_, pblID, _) = get_obj g_spec pt p';

     End_Program (Pstate ist, Tactic.Check_Postcond' (pblID, prog_result))
     (*return from find_next_step*);
"~~~~~ from fun find_next_step\<longrightarrow>and do_next\<longrightarrow>fun zzz, return:"; val (End_Program (ist, tac))
  = (End_Program (Pstate ist, Tactic.Check_Postcond' (pblID,prog_result)));
      val _ = (*case*) tac (*of*);

val ("ok", ([(Check_Postcond ["polynomial", "simplification"], _, _)], _, (_, ([], Res))))
   = LI.by_tactic tac (ist, ctxt) ptp (*return from and do_next*);
"~~~~~ from and do_next\<longrightarrow>top level, return:"; val (_, ([(tac''''', _, _)], _, (pt''''', p''''')))
  = (LI.by_tactic tac (ist, ctxt) ptp);
(*\\------------------ end of go into 2 -----------------------------------------------------//*)

(*[], Und*)val (msg, ([], _, (pt, p))) = Step.do_next p''''' ((pt''''', Pos.e_pos'), []);(**)

Test_Tool.show_pt_tac pt; (*[
([], Frm), Simplify (a + a)
. . . . . . . . . . Apply_Method ["simplification", "for_polynomials"],
([1], Frm), a + a
. . . . . . . . . . Rewrite_Set "norm_Poly",
([1], Res), 2 * a
. . . . . . . . . . Check_Postcond ["polynomial", "simplification"],
([], Res), 2 * a]*)

(*/--- final test ---------------------------------------------------------------------------\\*)
val (res, asm) = (get_obj g_result pt (fst p));
if UnparseC.term res = "2 * a" andalso map UnparseC.term asm = []
andalso p = ([], Und) andalso msg = "end-of-calculation"
andalso pr_ctree pr_short pt = ".    ----- pblobj -----\n1.   a + a\n"
then 
  case tac''''' of Check_Postcond ["polynomial", "simplification"] => () 
  | _ => error "re-build: fun find_next_step, mini 1"
else error "re-build: fun find_next_step, mini 2"


"----------- re-build: fun locate_input_term ---------------------------------------------------";
"----------- re-build: fun locate_input_term ---------------------------------------------------";
"----------- re-build: fun locate_input_term ---------------------------------------------------";
(*cp from inform.sml
 ----------- appendFormula: on Res + late deriv ------------------------------------------------*)
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["Test", "squ-equ-test-subpbl1"]*);

(*[1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;(*Rewrite_Set "norm_equation"*)
(*+*)if f2str f = "x + 1 = 2" then () else error "locate_input_term at ([1], Frm) CHANGED";

(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;(*Rewrite_Set "Test_simplify"*)
(*+*)if f2str f = "x + 1 + - 1 * 2 = 0" then () else error "locate_input_term at ([1], Frm) CHANGED";

Test_Tool.show_pt_tac pt; (*[
([], Frm), solve (x + 1 = 2, x)
. . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"],
([1], Frm), x + 1 = 2
. . . . . . . . . . Rewrite_Set "norm_equation",
([1], Res), x + 1 + - 1 * 2 = 0             ///Check_Postcond..ERROR*)

(*//---------- appendFormula 1 "x = 1" \<longrightarrow> Step_Solve.inform \<longrightarrow> LI.locate_input_term ----------\\*)
"~~~~~ fun appendFormula , args:"; val ((*cI, *) ifo: TermC.as_string) = ((**) "x = 1");
    val cs = (*States.get_calc cI*) ((pt, p), [(*nxt, nxt_, (pos, (ist, ctxt))*)])
    val pos = (*States.get_pos cI 1*) p

(*+*)val ptp''''' = (pt, p);
(*+*)if snd ptp''''' = ([1], Res) then () else error "old_cs changed";
(*+*)Test_Tool.show_pt_tac pt; (*[
(*+*)([], Frm), solve (x + 1 = 2, x)
(*+*). . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"],
(*+*)([1], Frm), x + 1 = 2
(*+*). . . . . . . . . . Rewrite_Set "norm_equation",
(*+*)([1], Res), x + 1 + - 1 * 2 = 0      ///Check_Postcond*)

  val ("ok", cs' as (_, _, ptp')) =
    (*case*) Step.do_next pos cs (*of*);

val ("ok", (_(*use in DG !!!*), [], ptp''''' as (pt''''', p'''''))) = (*case*)
     Step_Solve.by_term ptp' (encode ifo) (*of*);
"~~~~~ fun Step_Solve.by_term , args:"; val ((pt, pos as (p, _)), istr)
  = (ptp', (encode ifo));
  val SOME f_in =
    (*case*) TermC.parseNEW (get_ctxt pt pos) istr (*of*);
      val pos_pred = lev_back(*'*) pos
  	  val f_pred = Ctree.get_curr_formula (pt, pos_pred);
  	  val f_succ = Ctree.get_curr_formula (pt, pos);
      (*if*) f_succ = f_in (*else*);
  val NONE =
        (*case*) CAS_Cmd.input f_in (*of*);

(*NEW*) LI.locate_input_term (pt, pos) f_in (*of*);
"~~~~~ fun locate_input_term , args:"; val ((pt, pos), tm) = ((pt, pos), f_in);
   		val pos_pred = Pos.lev_back' pos (*f_pred ---"step pos cs"---> f_succ in appendFormula*)

  val ("ok", (_, _, cstate as (pt', pos'))) =
   		(*case*) compare_step ([], [], (pt, pos_pred)) tm (*of*);

(*old* )
    Found_Step (cstate, get_istate_LI pt' pos', get_ctxt pt' pos')  (*return from locate_input_term*);
( *old*)
(*NEW*)     Found_Step cstate (*return from locate_input_term*);
       (*LI.Found_Step ( *)cstate(*, _(*istate*), _)( *return from locate_input_term*);
"~~~~~ from fun locate_input_term\<longrightarrow>fun Step_Solve.by_term, return:"; val ("ok", (_(*use in DG !!!*), c, ptp as (_, p)))
  = (("ok" , ([], [], cstate (* already contains istate, ctxt *))));

    ("ok", ((*_ use in DG !!!,*) c, ptp(* as (_*), p))(*)*)(*return from Step_Solve.by_term*);
"~~~~~ from fun Step_Solve.by_term\<longrightarrow>(fun appendFormula)!toplevel, return:"; val ("ok", (_(*use in DG !!!*), [], ptp''''' as (pt''''', p''''')))
  = ("ok", ([], [], ptp));

(*fun me requires nxt...*)
    Step.do_next p''''' (ptp''''', []);
  val ("ok", ([(nxt'''''_' as Check_Postcond ["LINEAR", "univariate", "equation", "test"], _, _)], _,
    (pt'''''_', p'''''_'))) = Step.do_next p''''' (ptp''''', [])
(*\\---------- appendFormula 1 "x = 1" \<longrightarrow> Step_Solve.inform \<longrightarrow> LI.locate_input_term ----------//*)

(*//----- REPLACED BY appendFormula 1 "x = 1" \<longrightarrow> Step_Solve.inform \<longrightarrow> LI.locate_input_term -----\\* )
 (*[2], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Subproblem ("Test", ["LINEAR", "univariate", "equation", "test"])*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Model_Problem*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Given "equality (- 1 + x = 0)"*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Given "solveFor x"*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Add_Find "solutions x_i"*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Theory "Test"*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Problem ["LINEAR", "univariate", "equation", "test"]*)
 (*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Specify_Method ["Test", "solve_linear"]*)
 (*[3], Met*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Apply_Method ["Test", "solve_linear"]*)
 (*[3, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set_Inst (["(''bdv'', x)"], "isolate_bdv")*)
 (*[3, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Rewrite_Set "Test_simplify"*)
 (*[3, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Check_Postcond ["LINEAR", "univariate", "equation", "test"]*)
( *\\----- REPLACED BY appendFormula 1 "x = 1" \<longrightarrow> Step_Solve.inform \<longrightarrow> LI.locate_input_term -----//*)

 (*[3], Res*)val (p,_,f,nxt,_,pt) = me nxt'''''_' p'''''_' [] pt'''''_'; (*nxt = Check_elementwise "Assumptions"*)
 (*[4], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = Check_Postcond ["sqroot-test", "univariate", "equation", "test"]*)
 (*[], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*nxt = End_Proof'*)

(*/--- final test ---------------------------------------------------------------------------\\*)
if p = ([], Res) andalso f2str f = "[x = 1]" andalso pr_ctree pr_short pt =
   ".    ----- pblobj -----\n" ^
   "1.   x + 1 = 2\n" ^
   "2.   x + 1 + - 1 * 2 = 0\n" ^
   "3.    ----- pblobj -----\n" ^
   "3.1.   - 1 + x = 0\n" ^
   "3.2.   x = 0 + - 1 * - 1\n" ^
   "3.2.1.   x = 0 + - 1 * - 1\n" ^
   "3.2.2.   x = 0 + 1\n" (*ATTENTION: see complete Calc below*)
then case nxt of End_Proof' => () | _ => error "re-build: fun locate_input_term CHANGED 1"
else error "re-build: fun locate_input_term CHANGED 2";

Test_Tool.show_pt_tac pt; (*[
([], Frm), solve (x + 1 = 2, x)
. . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"],
([1], Frm), x + 1 = 2
. . . . . . . . . . Rewrite_Set "norm_equation",
([1], Res), x + 1 + - 1 * 2 = 0
. . . . . . . . . . Rewrite_Set "Test_simplify",
([2], Res), - 1 + x = 0
. . . . . . . . . . Subproblem (Test, ["LINEAR", "univariate", "equation", "test"]),
([3], Pbl), solve (- 1 + x = 0, x)
. . . . . . . . . . Apply_Method ["Test", "solve_linear"],
([3,1], Frm), - 1 + x = 0
. . . . . . . . . . Rewrite_Set_Inst ([(''bdv'', x)], "isolate_bdv"),
([3,1], Res), x = 0 + - 1 * - 1
. . . . . . . . . . Derive Test_simplify,
([3,2,1], Frm), x = 0 + - 1 * - 1
. . . . . . . . . . Rewrite ("#: - 1 * - 1 = 1", "- 1 * - 1 = 1"),
([3,2,1], Res), x = 0 + 1
. . . . . . . . . . Rewrite ("radd_0", "0 + ?k = ?k"),
([3,2,2], Res), x = 1
. . . . . . . . . . Tactic.input_to_string not impl. for ?!,
([3,2], Res), x = 1
. . . . . . . . . . Check_Postcond ["LINEAR", "univariate", "equation", "test"],
([3], Res), [x = 1]
. . . . . . . . . . Check_Postcond ["sqroot-test", "univariate", "equation", "test"],
([], Res), [x = 1]]*)
