(* Title:  100-init-rootpbl.sml
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.
*)

"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
val fmz = ["equality (AA+1=(2::real))", "solveFor AA", "solutions L"];
val (dI',pI',mI') =
  ("Isac_Knowledge", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
"~~~~~ fun CalcTreeTEST , args:"; val [(fmz, sp): Formalise.T] = [(fmz, (dI',pI',mI'))];

Step_Specify.nxt_specify_init_calc ctxt (fmz, sp);
"~~~~~ fun nxt_specify_init_calc , args:"; val (fmz, (dI, pI, mI)) = (fmz, sp);
	    val (_, hdl, (dI, pI, mI), pors, pctxt) = Step_Specify.initialise (fmz, (dI, pI, mI))
      val (pt, _) = cappend_problem e_ctree [] (Istate_Def.empty, pctxt)
        (fmz, (dI, pI, mI)) (pors, (dI, pI, mI), hdl, pctxt)
;
(*return value*)
((pt, ([], Pbl)), (fst3 o snd) (Step_Specify.by_tactic_input Model_Problem (pt, ([], Pbl)))) : Calc.state_pre;

(* INVESTIGATE val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];*)
(*///----------------------------------------- save for final check ------------------------\\\*)
val [(fmz''''', spec''''')] = [(fmz, (dI',pI',mI'))];
"~~~~~ fun CalcTreeTEST, args:"; val ([(fmz, sp)]) = ([(fmz, (dI',pI',mI'))]);
    val ((pt, p), tacis) = Step_Specify.nxt_specify_init_calc ctxt (fmz, sp)
(*ADD check*) 
val PblObj {origin= (oris, (dI', pI', mI'), _), spec= (dI, _, _), ctxt, ...} = get_obj I pt (fst p);
(* ERROR Specify.item_to_add: types or dsc DO NOT MATCH BETWEEN fmz --- pbt
   IN Minimsubpbl/150-add-given.sml IS CAUSED HEREBY:*)
case oris of
  [(1, [1], "#Given", Const (\<^const_name>\<open>Input_Descript.equality\<close>, _),
     [Const (\<^const_name>\<open>HOL.eq\<close>, _) $ (Const (\<^const_name>\<open>plus_class.plus\<close>, _) $ Const (\<^const_name>\<open>AA\<close>, _) $ Const (\<^const_name>\<open>one_class.one\<close>, _)) $
        (Const (\<^const_name>\<open>numeral\<close>, _) $ (Const (\<^const_name>\<open>num.Bit0\<close>, _) $ Const (\<^const_name>\<open>num.One\<close>, _)))]),
    (2, [1], "#Given", Const (\<^const_name>\<open>Input_Descript.solveFor\<close>, _), [Const (\<^const_name>\<open>AA\<close>, _)]),
    (3, [1], "#Find", Const (\<^const_name>\<open>Input_Descript.solutions\<close>, _), [Free ("L", _)])] => ()
| ((1, [1], "#undef", Const ("empty", _), _) :: _) => error "START specify: oris are not properly initialised"
| _ => error ""

"~~~~~ fun nxt_specify_init_calc, args:"; val (fmz, (dI, pI, mI)) = (fmz, sp);
	    val thy = ThyC.get_theory dI;
(*if*) mI = ["no_met"] = false (*else*);
val xxx = Problem.from_store ctxt pI
val yyy = #ppc xxx
val oris = O_Model.init thy fmz yyy
;
case oris of
  [(1, [1], "#Given", Const (\<^const_name>\<open>Input_Descript.equality\<close>, _),
     [Const (\<^const_name>\<open>HOL.eq\<close>, _) $ (Const (\<^const_name>\<open>plus_class.plus\<close>, _) $ Const (\<^const_name>\<open>AA\<close>, _) $ Const (\<^const_name>\<open>one_class.one\<close>, _)) $
        (Const (\<^const_name>\<open>numeral\<close>, _) $ (Const (\<^const_name>\<open>num.Bit0\<close>, _) $ Const (\<^const_name>\<open>num.One\<close>, _)))]),
    (2, [1], "#Given", Const (\<^const_name>\<open>Input_Descript.solveFor\<close>, _), [Const (\<^const_name>\<open>AA\<close>, _)]),
    (3, [1], "#Find", Const (\<^const_name>\<open>Input_Descript.solutions\<close>, _), [Free ("L", _)])] => ()
| ((1, [1], "#undef", Const ("empty", _), _) :: _) => error "START specify: oris are not properly initialised"
| _ => error ""

"~~~~~ fun O_Model.init , args:"; val (fmz, thy, pbt) = (thy, fmz, yyy);
      val ctxt = ContextC.initialise' fmz thy;
(*ADD check*) 
case TermC.parseNEW ctxt "equality (x+1=(2::real))" of
  SOME (Const (\<^const_name>\<open>Input_Descript.equality\<close>, _) $
    (Const (\<^const_name>\<open>HOL.eq\<close>, _) $ (Const (\<^const_name>\<open>plus_class.plus\<close>, _) $ Free ("x", _) $ Const (\<^const_name>\<open>one_class.one\<close>, _)) $
      (Const (\<^const_name>\<open>numeral\<close>, _) $ (Const (\<^const_name>\<open>num.Bit0\<close>, _) $ Const (\<^const_name>\<open>num.One\<close>, _))))
  ) => ()
| SOME (Free ("equality", _) $
    (Const (\<^const_name>\<open>HOL.eq\<close>, _) $ (Const (\<^const_name>\<open>plus_class.plus\<close>, _) $
      Free ("x", _) $ Free ("1", _)) $ Free ("2", _))) => error "xxx"
| _ => error "something is wrong with initialising Minisubpnl";

val [(fmz, (dI',pI',mI'))] = [(fmz''''', spec''''')];
(*\\\----------------------------------------- saved for final check -----------------------///*)

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
case nxt of Model_Problem => ()
| _ => error "minisubpbl: CalcTreeTEST has no nxt = Model_Problem";

Proof_Context.theory_of (Ctree.get_ctxt pt p); (*"Isac_Knowledge"*)
